<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source to the Rust file `/home/keir/.cargo/registry/src/github.com-1ecc6299db9ec823/rand-0.7.3/src/distributions/binomial.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>binomial.rs.html -- source</title><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../dark.css"><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script src="../../../storage.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="shortcut icon" href="https://www.rust-lang.org/favicon.ico"><style type="text/css">#crate-search{background-image:url("../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 8]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu">&#9776;</div><a href='../../../rand/index.html'><div class='logo-container'><img src='https://www.rust-lang.org/logos/rust-logo-128x128-blk.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!"><img src="../../../brush.svg" width="18" alt="Pick another theme!"></button><div id="theme-choices"></div></div><script src="../../../theme.js"></script><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><a id="settings-menu" href="../../../settings.html"><img src="../../../wheel.svg" width="18" alt="Change settings"></a></div></form></nav><section id="main" class="content"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
</pre><div class="example-wrap"><pre class="rust ">
<span class="comment">// Copyright 2018 Developers of the Rand project.</span>
<span class="comment">// Copyright 2016-2017 The Rust Project Developers.</span>
<span class="comment">//</span>
<span class="comment">// Licensed under the Apache License, Version 2.0 &lt;LICENSE-APACHE or</span>
<span class="comment">// https://www.apache.org/licenses/LICENSE-2.0&gt; or the MIT license</span>
<span class="comment">// &lt;LICENSE-MIT or https://opensource.org/licenses/MIT&gt;, at your</span>
<span class="comment">// option. This file may not be copied, modified, or distributed</span>
<span class="comment">// except according to those terms.</span>

<span class="doccomment">//! The binomial distribution.</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">clippy</span>::<span class="ident">all</span>)]</span>

<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">distributions</span>::{<span class="ident">Distribution</span>, <span class="ident">Uniform</span>};
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">Rng</span>;

<span class="doccomment">/// The binomial distribution `Binomial(n, p)`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This distribution has density function:</span>
<span class="doccomment">/// `f(k) = n!/(k! (n-k)!) p^k (1-p)^(n-k)` for `k &gt;= 0`.</span>
<span class="attribute">#[<span class="ident">deprecated</span>(<span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;0.7.0&quot;</span>, <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;moved to rand_distr crate&quot;</span>)]</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Binomial</span> {
    <span class="doccomment">/// Number of trials.</span>
    <span class="ident">n</span>: <span class="ident">u64</span>,
    <span class="doccomment">/// Probability of success.</span>
    <span class="ident">p</span>: <span class="ident">f64</span>,
}

<span class="kw">impl</span> <span class="ident">Binomial</span> {
    <span class="doccomment">/// Construct a new `Binomial` with the given shape parameters `n` (number</span>
    <span class="doccomment">/// of trials) and `p` (probability of success).</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Panics if `p &lt; 0` or `p &gt; 1`.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">n</span>: <span class="ident">u64</span>, <span class="ident">p</span>: <span class="ident">f64</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Binomial</span> {
        <span class="macro">assert</span><span class="macro">!</span>(<span class="ident">p</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">0.0</span>, <span class="string">&quot;Binomial::new called with p &lt; 0&quot;</span>);
        <span class="macro">assert</span><span class="macro">!</span>(<span class="ident">p</span> <span class="op">&lt;</span><span class="op">=</span> <span class="number">1.0</span>, <span class="string">&quot;Binomial::new called with p &gt; 1&quot;</span>);
        <span class="ident">Binomial</span> { <span class="ident">n</span>, <span class="ident">p</span> }
    }
}

<span class="doccomment">/// Convert a `f64` to an `i64`, panicing on overflow.</span>
<span class="comment">// In the future (Rust 1.34), this might be replaced with `TryFrom`.</span>
<span class="kw">fn</span> <span class="ident">f64_to_i64</span>(<span class="ident">x</span>: <span class="ident">f64</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">i64</span> {
    <span class="macro">assert</span><span class="macro">!</span>(<span class="ident">x</span> <span class="op">&lt;</span> (::<span class="ident">std</span>::<span class="ident">i64</span>::<span class="ident">MAX</span> <span class="kw">as</span> <span class="ident">f64</span>));
    <span class="ident">x</span> <span class="kw">as</span> <span class="ident">i64</span>
}

<span class="kw">impl</span> <span class="ident">Distribution</span><span class="op">&lt;</span><span class="ident">u64</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">Binomial</span> {
    <span class="kw">fn</span> <span class="ident">sample</span><span class="op">&lt;</span><span class="ident">R</span>: <span class="ident">Rng</span> <span class="op">+</span> <span class="question-mark">?</span><span class="ident">Sized</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">rng</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">R</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">u64</span> {
        <span class="comment">// Handle these values directly.</span>
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">p</span> <span class="op">=</span><span class="op">=</span> <span class="number">0.0</span> {
            <span class="kw">return</span> <span class="number">0</span>;
        } <span class="kw">else</span> <span class="kw">if</span> <span class="self">self</span>.<span class="ident">p</span> <span class="op">=</span><span class="op">=</span> <span class="number">1.0</span> {
            <span class="kw">return</span> <span class="self">self</span>.<span class="ident">n</span>;
        }

        <span class="comment">// The binomial distribution is symmetrical with respect to p -&gt; 1-p,</span>
        <span class="comment">// k -&gt; n-k switch p so that it is less than 0.5 - this allows for lower</span>
        <span class="comment">// expected values we will just invert the result at the end</span>
        <span class="kw">let</span> <span class="ident">p</span> <span class="op">=</span> <span class="kw">if</span> <span class="self">self</span>.<span class="ident">p</span> <span class="op">&lt;</span><span class="op">=</span> <span class="number">0.5</span> { <span class="self">self</span>.<span class="ident">p</span> } <span class="kw">else</span> { <span class="number">1.0</span> <span class="op">-</span> <span class="self">self</span>.<span class="ident">p</span> };

        <span class="kw">let</span> <span class="ident">result</span>;
        <span class="kw">let</span> <span class="ident">q</span> <span class="op">=</span> <span class="number">1.</span> <span class="op">-</span> <span class="ident">p</span>;

        <span class="comment">// For small n * min(p, 1 - p), the BINV algorithm based on the inverse</span>
        <span class="comment">// transformation of the binomial distribution is efficient. Otherwise,</span>
        <span class="comment">// the BTPE algorithm is used.</span>
        <span class="comment">//</span>
        <span class="comment">// Voratas Kachitvichyanukul and Bruce W. Schmeiser. 1988. Binomial</span>
        <span class="comment">// random variate generation. Commun. ACM 31, 2 (February 1988),</span>
        <span class="comment">// 216-222. http://dx.doi.org/10.1145/42372.42381</span>

        <span class="comment">// Threshold for prefering the BINV algorithm. The paper suggests 10,</span>
        <span class="comment">// Ranlib uses 30, and GSL uses 14.</span>
        <span class="kw">const</span> <span class="ident">BINV_THRESHOLD</span>: <span class="ident">f64</span> <span class="op">=</span> <span class="number">10.</span>;

        <span class="kw">if</span> (<span class="self">self</span>.<span class="ident">n</span> <span class="kw">as</span> <span class="ident">f64</span>) <span class="op">*</span> <span class="ident">p</span> <span class="op">&lt;</span> <span class="ident">BINV_THRESHOLD</span> <span class="kw-2">&amp;</span><span class="op">&amp;</span> <span class="self">self</span>.<span class="ident">n</span> <span class="op">&lt;</span><span class="op">=</span> (::<span class="ident">std</span>::<span class="ident">i32</span>::<span class="ident">MAX</span> <span class="kw">as</span> <span class="ident">u64</span>) {
            <span class="comment">// Use the BINV algorithm.</span>
            <span class="kw">let</span> <span class="ident">s</span> <span class="op">=</span> <span class="ident">p</span> <span class="op">/</span> <span class="ident">q</span>;
            <span class="kw">let</span> <span class="ident">a</span> <span class="op">=</span> ((<span class="self">self</span>.<span class="ident">n</span> <span class="op">+</span> <span class="number">1</span>) <span class="kw">as</span> <span class="ident">f64</span>) <span class="op">*</span> <span class="ident">s</span>;
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">r</span> <span class="op">=</span> <span class="ident">q</span>.<span class="ident">powi</span>(<span class="self">self</span>.<span class="ident">n</span> <span class="kw">as</span> <span class="ident">i32</span>);
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">u</span>: <span class="ident">f64</span> <span class="op">=</span> <span class="ident">rng</span>.<span class="ident">gen</span>();
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">x</span> <span class="op">=</span> <span class="number">0</span>;
            <span class="kw">while</span> <span class="ident">u</span> <span class="op">&gt;</span> <span class="ident">r</span> <span class="kw">as</span> <span class="ident">f64</span> {
                <span class="ident">u</span> <span class="op">-</span><span class="op">=</span> <span class="ident">r</span>;
                <span class="ident">x</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
                <span class="ident">r</span> <span class="kw-2">*</span><span class="op">=</span> <span class="ident">a</span> <span class="op">/</span> (<span class="ident">x</span> <span class="kw">as</span> <span class="ident">f64</span>) <span class="op">-</span> <span class="ident">s</span>;
            }
            <span class="ident">result</span> <span class="op">=</span> <span class="ident">x</span>;
        } <span class="kw">else</span> {
            <span class="comment">// Use the BTPE algorithm.</span>

            <span class="comment">// Threshold for using the squeeze algorithm. This can be freely</span>
            <span class="comment">// chosen based on performance. Ranlib and GSL use 20.</span>
            <span class="kw">const</span> <span class="ident">SQUEEZE_THRESHOLD</span>: <span class="ident">i64</span> <span class="op">=</span> <span class="number">20</span>;

            <span class="comment">// Step 0: Calculate constants as functions of `n` and `p`.</span>
            <span class="kw">let</span> <span class="ident">n</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">n</span> <span class="kw">as</span> <span class="ident">f64</span>;
            <span class="kw">let</span> <span class="ident">np</span> <span class="op">=</span> <span class="ident">n</span> <span class="op">*</span> <span class="ident">p</span>;
            <span class="kw">let</span> <span class="ident">npq</span> <span class="op">=</span> <span class="ident">np</span> <span class="op">*</span> <span class="ident">q</span>;
            <span class="kw">let</span> <span class="ident">f_m</span> <span class="op">=</span> <span class="ident">np</span> <span class="op">+</span> <span class="ident">p</span>;
            <span class="kw">let</span> <span class="ident">m</span> <span class="op">=</span> <span class="ident">f64_to_i64</span>(<span class="ident">f_m</span>);
            <span class="comment">// radius of triangle region, since height=1 also area of region</span>
            <span class="kw">let</span> <span class="ident">p1</span> <span class="op">=</span> (<span class="number">2.195</span> <span class="op">*</span> <span class="ident">npq</span>.<span class="ident">sqrt</span>() <span class="op">-</span> <span class="number">4.6</span> <span class="op">*</span> <span class="ident">q</span>).<span class="ident">floor</span>() <span class="op">+</span> <span class="number">0.5</span>;
            <span class="comment">// tip of triangle</span>
            <span class="kw">let</span> <span class="ident">x_m</span> <span class="op">=</span> (<span class="ident">m</span> <span class="kw">as</span> <span class="ident">f64</span>) <span class="op">+</span> <span class="number">0.5</span>;
            <span class="comment">// left edge of triangle</span>
            <span class="kw">let</span> <span class="ident">x_l</span> <span class="op">=</span> <span class="ident">x_m</span> <span class="op">-</span> <span class="ident">p1</span>;
            <span class="comment">// right edge of triangle</span>
            <span class="kw">let</span> <span class="ident">x_r</span> <span class="op">=</span> <span class="ident">x_m</span> <span class="op">+</span> <span class="ident">p1</span>;
            <span class="kw">let</span> <span class="ident">c</span> <span class="op">=</span> <span class="number">0.134</span> <span class="op">+</span> <span class="number">20.5</span> <span class="op">/</span> (<span class="number">15.3</span> <span class="op">+</span> (<span class="ident">m</span> <span class="kw">as</span> <span class="ident">f64</span>));
            <span class="comment">// p1 + area of parallelogram region</span>
            <span class="kw">let</span> <span class="ident">p2</span> <span class="op">=</span> <span class="ident">p1</span> <span class="op">*</span> (<span class="number">1.</span> <span class="op">+</span> <span class="number">2.</span> <span class="op">*</span> <span class="ident">c</span>);

            <span class="kw">fn</span> <span class="ident">lambda</span>(<span class="ident">a</span>: <span class="ident">f64</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">f64</span> {
                <span class="ident">a</span> <span class="op">*</span> (<span class="number">1.</span> <span class="op">+</span> <span class="number">0.5</span> <span class="op">*</span> <span class="ident">a</span>)
            }

            <span class="kw">let</span> <span class="ident">lambda_l</span> <span class="op">=</span> <span class="ident">lambda</span>((<span class="ident">f_m</span> <span class="op">-</span> <span class="ident">x_l</span>) <span class="op">/</span> (<span class="ident">f_m</span> <span class="op">-</span> <span class="ident">x_l</span> <span class="op">*</span> <span class="ident">p</span>));
            <span class="kw">let</span> <span class="ident">lambda_r</span> <span class="op">=</span> <span class="ident">lambda</span>((<span class="ident">x_r</span> <span class="op">-</span> <span class="ident">f_m</span>) <span class="op">/</span> (<span class="ident">x_r</span> <span class="op">*</span> <span class="ident">q</span>));
            <span class="comment">// p1 + area of left tail</span>
            <span class="kw">let</span> <span class="ident">p3</span> <span class="op">=</span> <span class="ident">p2</span> <span class="op">+</span> <span class="ident">c</span> <span class="op">/</span> <span class="ident">lambda_l</span>;
            <span class="comment">// p1 + area of right tail</span>
            <span class="kw">let</span> <span class="ident">p4</span> <span class="op">=</span> <span class="ident">p3</span> <span class="op">+</span> <span class="ident">c</span> <span class="op">/</span> <span class="ident">lambda_r</span>;

            <span class="comment">// return value</span>
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">y</span>: <span class="ident">i64</span>;

            <span class="kw">let</span> <span class="ident">gen_u</span> <span class="op">=</span> <span class="ident">Uniform</span>::<span class="ident">new</span>(<span class="number">0.</span>, <span class="ident">p4</span>);
            <span class="kw">let</span> <span class="ident">gen_v</span> <span class="op">=</span> <span class="ident">Uniform</span>::<span class="ident">new</span>(<span class="number">0.</span>, <span class="number">1.</span>);

            <span class="kw">loop</span> {
                <span class="comment">// Step 1: Generate `u` for selecting the region. If region 1 is</span>
                <span class="comment">// selected, generate a triangularly distributed variate.</span>
                <span class="kw">let</span> <span class="ident">u</span> <span class="op">=</span> <span class="ident">gen_u</span>.<span class="ident">sample</span>(<span class="ident">rng</span>);
                <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">v</span> <span class="op">=</span> <span class="ident">gen_v</span>.<span class="ident">sample</span>(<span class="ident">rng</span>);
                <span class="kw">if</span> <span class="op">!</span>(<span class="ident">u</span> <span class="op">&gt;</span> <span class="ident">p1</span>) {
                    <span class="ident">y</span> <span class="op">=</span> <span class="ident">f64_to_i64</span>(<span class="ident">x_m</span> <span class="op">-</span> <span class="ident">p1</span> <span class="op">*</span> <span class="ident">v</span> <span class="op">+</span> <span class="ident">u</span>);
                    <span class="kw">break</span>;
                }

                <span class="kw">if</span> <span class="op">!</span>(<span class="ident">u</span> <span class="op">&gt;</span> <span class="ident">p2</span>) {
                    <span class="comment">// Step 2: Region 2, parallelograms. Check if region 2 is</span>
                    <span class="comment">// used. If so, generate `y`.</span>
                    <span class="kw">let</span> <span class="ident">x</span> <span class="op">=</span> <span class="ident">x_l</span> <span class="op">+</span> (<span class="ident">u</span> <span class="op">-</span> <span class="ident">p1</span>) <span class="op">/</span> <span class="ident">c</span>;
                    <span class="ident">v</span> <span class="op">=</span> <span class="ident">v</span> <span class="op">*</span> <span class="ident">c</span> <span class="op">+</span> <span class="number">1.0</span> <span class="op">-</span> (<span class="ident">x</span> <span class="op">-</span> <span class="ident">x_m</span>).<span class="ident">abs</span>() <span class="op">/</span> <span class="ident">p1</span>;
                    <span class="kw">if</span> <span class="ident">v</span> <span class="op">&gt;</span> <span class="number">1.</span> {
                        <span class="kw">continue</span>;
                    } <span class="kw">else</span> {
                        <span class="ident">y</span> <span class="op">=</span> <span class="ident">f64_to_i64</span>(<span class="ident">x</span>);
                    }
                } <span class="kw">else</span> <span class="kw">if</span> <span class="op">!</span>(<span class="ident">u</span> <span class="op">&gt;</span> <span class="ident">p3</span>) {
                    <span class="comment">// Step 3: Region 3, left exponential tail.</span>
                    <span class="ident">y</span> <span class="op">=</span> <span class="ident">f64_to_i64</span>(<span class="ident">x_l</span> <span class="op">+</span> <span class="ident">v</span>.<span class="ident">ln</span>() <span class="op">/</span> <span class="ident">lambda_l</span>);
                    <span class="kw">if</span> <span class="ident">y</span> <span class="op">&lt;</span> <span class="number">0</span> {
                        <span class="kw">continue</span>;
                    } <span class="kw">else</span> {
                        <span class="ident">v</span> <span class="kw-2">*</span><span class="op">=</span> (<span class="ident">u</span> <span class="op">-</span> <span class="ident">p2</span>) <span class="op">*</span> <span class="ident">lambda_l</span>;
                    }
                } <span class="kw">else</span> {
                    <span class="comment">// Step 4: Region 4, right exponential tail.</span>
                    <span class="ident">y</span> <span class="op">=</span> <span class="ident">f64_to_i64</span>(<span class="ident">x_r</span> <span class="op">-</span> <span class="ident">v</span>.<span class="ident">ln</span>() <span class="op">/</span> <span class="ident">lambda_r</span>);
                    <span class="kw">if</span> <span class="ident">y</span> <span class="op">&gt;</span> <span class="number">0</span> <span class="kw-2">&amp;</span><span class="op">&amp;</span> (<span class="ident">y</span> <span class="kw">as</span> <span class="ident">u64</span>) <span class="op">&gt;</span> <span class="self">self</span>.<span class="ident">n</span> {
                        <span class="kw">continue</span>;
                    } <span class="kw">else</span> {
                        <span class="ident">v</span> <span class="kw-2">*</span><span class="op">=</span> (<span class="ident">u</span> <span class="op">-</span> <span class="ident">p3</span>) <span class="op">*</span> <span class="ident">lambda_r</span>;
                    }
                }

                <span class="comment">// Step 5: Acceptance/rejection comparison.</span>

                <span class="comment">// Step 5.0: Test for appropriate method of evaluating f(y).</span>
                <span class="kw">let</span> <span class="ident">k</span> <span class="op">=</span> (<span class="ident">y</span> <span class="op">-</span> <span class="ident">m</span>).<span class="ident">abs</span>();
                <span class="kw">if</span> <span class="op">!</span>(<span class="ident">k</span> <span class="op">&gt;</span> <span class="ident">SQUEEZE_THRESHOLD</span> <span class="kw-2">&amp;</span><span class="op">&amp;</span> (<span class="ident">k</span> <span class="kw">as</span> <span class="ident">f64</span>) <span class="op">&lt;</span> <span class="number">0.5</span> <span class="op">*</span> <span class="ident">npq</span> <span class="op">-</span> <span class="number">1.</span>) {
                    <span class="comment">// Step 5.1: Evaluate f(y) via the recursive relationship. Start the</span>
                    <span class="comment">// search from the mode.</span>
                    <span class="kw">let</span> <span class="ident">s</span> <span class="op">=</span> <span class="ident">p</span> <span class="op">/</span> <span class="ident">q</span>;
                    <span class="kw">let</span> <span class="ident">a</span> <span class="op">=</span> <span class="ident">s</span> <span class="op">*</span> (<span class="ident">n</span> <span class="op">+</span> <span class="number">1.</span>);
                    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">f</span> <span class="op">=</span> <span class="number">1.0</span>;
                    <span class="kw">if</span> <span class="ident">m</span> <span class="op">&lt;</span> <span class="ident">y</span> {
                        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">i</span> <span class="op">=</span> <span class="ident">m</span>;
                        <span class="kw">loop</span> {
                            <span class="ident">i</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
                            <span class="ident">f</span> <span class="kw-2">*</span><span class="op">=</span> <span class="ident">a</span> <span class="op">/</span> (<span class="ident">i</span> <span class="kw">as</span> <span class="ident">f64</span>) <span class="op">-</span> <span class="ident">s</span>;
                            <span class="kw">if</span> <span class="ident">i</span> <span class="op">=</span><span class="op">=</span> <span class="ident">y</span> {
                                <span class="kw">break</span>;
                            }
                        }
                    } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">m</span> <span class="op">&gt;</span> <span class="ident">y</span> {
                        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">i</span> <span class="op">=</span> <span class="ident">y</span>;
                        <span class="kw">loop</span> {
                            <span class="ident">i</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
                            <span class="ident">f</span> <span class="op">/</span><span class="op">=</span> <span class="ident">a</span> <span class="op">/</span> (<span class="ident">i</span> <span class="kw">as</span> <span class="ident">f64</span>) <span class="op">-</span> <span class="ident">s</span>;
                            <span class="kw">if</span> <span class="ident">i</span> <span class="op">=</span><span class="op">=</span> <span class="ident">m</span> {
                                <span class="kw">break</span>;
                            }
                        }
                    }
                    <span class="kw">if</span> <span class="ident">v</span> <span class="op">&gt;</span> <span class="ident">f</span> {
                        <span class="kw">continue</span>;
                    } <span class="kw">else</span> {
                        <span class="kw">break</span>;
                    }
                }

                <span class="comment">// Step 5.2: Squeezing. Check the value of ln(v) againts upper and</span>
                <span class="comment">// lower bound of ln(f(y)).</span>
                <span class="kw">let</span> <span class="ident">k</span> <span class="op">=</span> <span class="ident">k</span> <span class="kw">as</span> <span class="ident">f64</span>;
                <span class="kw">let</span> <span class="ident">rho</span> <span class="op">=</span> (<span class="ident">k</span> <span class="op">/</span> <span class="ident">npq</span>) <span class="op">*</span> ((<span class="ident">k</span> <span class="op">*</span> (<span class="ident">k</span> <span class="op">/</span> <span class="number">3.</span> <span class="op">+</span> <span class="number">0.625</span>) <span class="op">+</span> <span class="number">1.</span> <span class="op">/</span> <span class="number">6.</span>) <span class="op">/</span> <span class="ident">npq</span> <span class="op">+</span> <span class="number">0.5</span>);
                <span class="kw">let</span> <span class="ident">t</span> <span class="op">=</span> <span class="op">-</span><span class="number">0.5</span> <span class="op">*</span> <span class="ident">k</span> <span class="op">*</span> <span class="ident">k</span> <span class="op">/</span> <span class="ident">npq</span>;
                <span class="kw">let</span> <span class="ident">alpha</span> <span class="op">=</span> <span class="ident">v</span>.<span class="ident">ln</span>();
                <span class="kw">if</span> <span class="ident">alpha</span> <span class="op">&lt;</span> <span class="ident">t</span> <span class="op">-</span> <span class="ident">rho</span> {
                    <span class="kw">break</span>;
                }
                <span class="kw">if</span> <span class="ident">alpha</span> <span class="op">&gt;</span> <span class="ident">t</span> <span class="op">+</span> <span class="ident">rho</span> {
                    <span class="kw">continue</span>;
                }

                <span class="comment">// Step 5.3: Final acceptance/rejection test.</span>
                <span class="kw">let</span> <span class="ident">x1</span> <span class="op">=</span> (<span class="ident">y</span> <span class="op">+</span> <span class="number">1</span>) <span class="kw">as</span> <span class="ident">f64</span>;
                <span class="kw">let</span> <span class="ident">f1</span> <span class="op">=</span> (<span class="ident">m</span> <span class="op">+</span> <span class="number">1</span>) <span class="kw">as</span> <span class="ident">f64</span>;
                <span class="kw">let</span> <span class="ident">z</span> <span class="op">=</span> (<span class="ident">f64_to_i64</span>(<span class="ident">n</span>) <span class="op">+</span> <span class="number">1</span> <span class="op">-</span> <span class="ident">m</span>) <span class="kw">as</span> <span class="ident">f64</span>;
                <span class="kw">let</span> <span class="ident">w</span> <span class="op">=</span> (<span class="ident">f64_to_i64</span>(<span class="ident">n</span>) <span class="op">-</span> <span class="ident">y</span> <span class="op">+</span> <span class="number">1</span>) <span class="kw">as</span> <span class="ident">f64</span>;

                <span class="kw">fn</span> <span class="ident">stirling</span>(<span class="ident">a</span>: <span class="ident">f64</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">f64</span> {
                    <span class="kw">let</span> <span class="ident">a2</span> <span class="op">=</span> <span class="ident">a</span> <span class="op">*</span> <span class="ident">a</span>;
                    (<span class="number">13860.</span> <span class="op">-</span> (<span class="number">462.</span> <span class="op">-</span> (<span class="number">132.</span> <span class="op">-</span> (<span class="number">99.</span> <span class="op">-</span> <span class="number">140.</span> <span class="op">/</span> <span class="ident">a2</span>) <span class="op">/</span> <span class="ident">a2</span>) <span class="op">/</span> <span class="ident">a2</span>) <span class="op">/</span> <span class="ident">a2</span>) <span class="op">/</span> <span class="ident">a</span> <span class="op">/</span> <span class="number">166320.</span>
                }

                <span class="kw">if</span> <span class="ident">alpha</span>
                        <span class="op">&gt;</span> <span class="ident">x_m</span> <span class="op">*</span> (<span class="ident">f1</span> <span class="op">/</span> <span class="ident">x1</span>).<span class="ident">ln</span>()
                        <span class="op">+</span> (<span class="ident">n</span> <span class="op">-</span> (<span class="ident">m</span> <span class="kw">as</span> <span class="ident">f64</span>) <span class="op">+</span> <span class="number">0.5</span>) <span class="op">*</span> (<span class="ident">z</span> <span class="op">/</span> <span class="ident">w</span>).<span class="ident">ln</span>()
                        <span class="op">+</span> ((<span class="ident">y</span> <span class="op">-</span> <span class="ident">m</span>) <span class="kw">as</span> <span class="ident">f64</span>) <span class="op">*</span> (<span class="ident">w</span> <span class="op">*</span> <span class="ident">p</span> <span class="op">/</span> (<span class="ident">x1</span> <span class="op">*</span> <span class="ident">q</span>)).<span class="ident">ln</span>()
                        <span class="comment">// We use the signs from the GSL implementation, which are</span>
                        <span class="comment">// different than the ones in the reference. According to</span>
                        <span class="comment">// the GSL authors, the new signs were verified to be</span>
                        <span class="comment">// correct by one of the original designers of the</span>
                        <span class="comment">// algorithm.</span>
                        <span class="op">+</span> <span class="ident">stirling</span>(<span class="ident">f1</span>)
                        <span class="op">+</span> <span class="ident">stirling</span>(<span class="ident">z</span>)
                        <span class="op">-</span> <span class="ident">stirling</span>(<span class="ident">x1</span>)
                        <span class="op">-</span> <span class="ident">stirling</span>(<span class="ident">w</span>)
                {
                    <span class="kw">continue</span>;
                }

                <span class="kw">break</span>;
            }
            <span class="macro">assert</span><span class="macro">!</span>(<span class="ident">y</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">0</span>);
            <span class="ident">result</span> <span class="op">=</span> <span class="ident">y</span> <span class="kw">as</span> <span class="ident">u64</span>;
        }

        <span class="comment">// Invert the result for p &lt; 0.5.</span>
        <span class="kw">if</span> <span class="ident">p</span> <span class="op">!</span><span class="op">=</span> <span class="self">self</span>.<span class="ident">p</span> {
            <span class="self">self</span>.<span class="ident">n</span> <span class="op">-</span> <span class="ident">result</span>
        } <span class="kw">else</span> {
            <span class="ident">result</span>
        }
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">test</span> {
    <span class="kw">use</span> <span class="kw">super</span>::<span class="ident">Binomial</span>;
    <span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">distributions</span>::<span class="ident">Distribution</span>;
    <span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">Rng</span>;

    <span class="kw">fn</span> <span class="ident">test_binomial_mean_and_variance</span><span class="op">&lt;</span><span class="ident">R</span>: <span class="ident">Rng</span><span class="op">&gt;</span>(<span class="ident">n</span>: <span class="ident">u64</span>, <span class="ident">p</span>: <span class="ident">f64</span>, <span class="ident">rng</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">R</span>) {
        <span class="kw">let</span> <span class="ident">binomial</span> <span class="op">=</span> <span class="ident">Binomial</span>::<span class="ident">new</span>(<span class="ident">n</span>, <span class="ident">p</span>);

        <span class="kw">let</span> <span class="ident">expected_mean</span> <span class="op">=</span> <span class="ident">n</span> <span class="kw">as</span> <span class="ident">f64</span> <span class="op">*</span> <span class="ident">p</span>;
        <span class="kw">let</span> <span class="ident">expected_variance</span> <span class="op">=</span> <span class="ident">n</span> <span class="kw">as</span> <span class="ident">f64</span> <span class="op">*</span> <span class="ident">p</span> <span class="op">*</span> (<span class="number">1.0</span> <span class="op">-</span> <span class="ident">p</span>);

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">results</span> <span class="op">=</span> [<span class="number">0.0</span>; <span class="number">1000</span>];
        <span class="kw">for</span> <span class="ident">i</span> <span class="kw">in</span> <span class="ident">results</span>.<span class="ident">iter_mut</span>() {
            <span class="kw-2">*</span><span class="ident">i</span> <span class="op">=</span> <span class="ident">binomial</span>.<span class="ident">sample</span>(<span class="ident">rng</span>) <span class="kw">as</span> <span class="ident">f64</span>;
        }

        <span class="kw">let</span> <span class="ident">mean</span> <span class="op">=</span> <span class="ident">results</span>.<span class="ident">iter</span>().<span class="ident">sum</span>::<span class="op">&lt;</span><span class="ident">f64</span><span class="op">&gt;</span>() <span class="op">/</span> <span class="ident">results</span>.<span class="ident">len</span>() <span class="kw">as</span> <span class="ident">f64</span>;
        <span class="macro">assert</span><span class="macro">!</span>(
            (<span class="ident">mean</span> <span class="kw">as</span> <span class="ident">f64</span> <span class="op">-</span> <span class="ident">expected_mean</span>).<span class="ident">abs</span>() <span class="op">&lt;</span> <span class="ident">expected_mean</span> <span class="op">/</span> <span class="number">50.0</span>,
            <span class="string">&quot;mean: {}, expected_mean: {}&quot;</span>,
            <span class="ident">mean</span>,
            <span class="ident">expected_mean</span>
        );

        <span class="kw">let</span> <span class="ident">variance</span> <span class="op">=</span>
            <span class="ident">results</span>.<span class="ident">iter</span>().<span class="ident">map</span>(<span class="op">|</span><span class="ident">x</span><span class="op">|</span> (<span class="ident">x</span> <span class="op">-</span> <span class="ident">mean</span>) <span class="op">*</span> (<span class="ident">x</span> <span class="op">-</span> <span class="ident">mean</span>)).<span class="ident">sum</span>::<span class="op">&lt;</span><span class="ident">f64</span><span class="op">&gt;</span>() <span class="op">/</span> <span class="ident">results</span>.<span class="ident">len</span>() <span class="kw">as</span> <span class="ident">f64</span>;
        <span class="macro">assert</span><span class="macro">!</span>(
            (<span class="ident">variance</span> <span class="op">-</span> <span class="ident">expected_variance</span>).<span class="ident">abs</span>() <span class="op">&lt;</span> <span class="ident">expected_variance</span> <span class="op">/</span> <span class="number">10.0</span>,
            <span class="string">&quot;variance: {}, expected_variance: {}&quot;</span>,
            <span class="ident">variance</span>,
            <span class="ident">expected_variance</span>
        );
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">miri</span>, <span class="ident">ignore</span>)]</span> <span class="comment">// Miri is too slow</span>
    <span class="kw">fn</span> <span class="ident">test_binomial</span>() {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">rng</span> <span class="op">=</span> <span class="kw">crate</span>::<span class="ident">test</span>::<span class="ident">rng</span>(<span class="number">351</span>);
        <span class="ident">test_binomial_mean_and_variance</span>(<span class="number">150</span>, <span class="number">0.1</span>, <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">rng</span>);
        <span class="ident">test_binomial_mean_and_variance</span>(<span class="number">70</span>, <span class="number">0.6</span>, <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">rng</span>);
        <span class="ident">test_binomial_mean_and_variance</span>(<span class="number">40</span>, <span class="number">0.5</span>, <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">rng</span>);
        <span class="ident">test_binomial_mean_and_variance</span>(<span class="number">20</span>, <span class="number">0.7</span>, <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">rng</span>);
        <span class="ident">test_binomial_mean_and_variance</span>(<span class="number">20</span>, <span class="number">0.5</span>, <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">rng</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_binomial_end_points</span>() {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">rng</span> <span class="op">=</span> <span class="kw">crate</span>::<span class="ident">test</span>::<span class="ident">rng</span>(<span class="number">352</span>);
        <span class="macro">assert_eq</span><span class="macro">!</span>(<span class="ident">rng</span>.<span class="ident">sample</span>(<span class="ident">Binomial</span>::<span class="ident">new</span>(<span class="number">20</span>, <span class="number">0.0</span>)), <span class="number">0</span>);
        <span class="macro">assert_eq</span><span class="macro">!</span>(<span class="ident">rng</span>.<span class="ident">sample</span>(<span class="ident">Binomial</span>::<span class="ident">new</span>(<span class="number">20</span>, <span class="number">1.0</span>)), <span class="number">20</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">should_panic</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_binomial_invalid_lambda_neg</span>() {
        <span class="ident">Binomial</span>::<span class="ident">new</span>(<span class="number">20</span>, <span class="op">-</span><span class="number">10.0</span>);
    }
}
</pre></div>
</section><section id="search" class="content hidden"></section><section class="footer"></section><script>window.rootPath = "../../../";window.currentCrate = "rand";</script><script src="../../../main.js"></script><script src="../../../source-script.js"></script><script src="../../../source-files.js"></script><script defer src="../../../search-index.js"></script></body></html>